// Copyright 2022 the Kilo authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/squat/kilo/pkg/k8s/apis/kilo/v1alpha1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// PeerLister helps list Peers.
// All objects returned here must be treated as read-only.
type PeerLister interface {
	// List lists all Peers in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.Peer, err error)
	// Get retrieves the Peer from the index for a given name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.Peer, error)
	PeerListerExpansion
}

// peerLister implements the PeerLister interface.
type peerLister struct {
	indexer cache.Indexer
}

// NewPeerLister returns a new PeerLister.
func NewPeerLister(indexer cache.Indexer) PeerLister {
	return &peerLister{indexer: indexer}
}

// List lists all Peers in the indexer.
func (s *peerLister) List(selector labels.Selector) (ret []*v1alpha1.Peer, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.Peer))
	})
	return ret, err
}

// Get retrieves the Peer from the index for a given name.
func (s *peerLister) Get(name string) (*v1alpha1.Peer, error) {
	obj, exists, err := s.indexer.GetByKey(name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("peer"), name)
	}
	return obj.(*v1alpha1.Peer), nil
}
